#include "Lexer.h"
#include "Parser.h"
#include <stdio.h>
#include <map>
void HandleDefinition();
void HandleExtern();
void HandleTopLevelExpression();

using namespace llvm;
extern std::map<char, int> BinOpPrecedence;
extern char CurTok;
extern std::unique_ptr<Module> TheModule;
extern LLVMContext TheContext;
int main(int argc, char *argv[]){
    BinOpPrecedence['<'] = 10;
    BinOpPrecedence['+'] = 20;
    BinOpPrecedence['-'] = 20;
    BinOpPrecedence['*'] = 40;
    fprintf(stderr, "ready> ");
    getNextToken();

    TheModule = llvm::make_unique<Module>("my cool jit", TheContext);
    while(1){
        fprintf(stderr, "ready> ");
        switch (CurTok) {
            case tok_eof:
                return 0;
            case ';':
                getNextToken();
                break;
            case tok_def:
                HandleDefinition();
                break;
            case tok_extern:
                HandleExtern();
                break;
            default:
                HandleTopLevelExpression();
                break;
        }
    }
    TheModule->dump();
    fprintf(stderr, "hi bro");
    return 0;
}

void HandleDefinition() {
    if (auto FnAST = ParseDefinition()) {
        if (auto *FnIR = FnAST->codegen()) {
            fprintf(stderr, "Parsed a function definition.\n");
            FnIR->dump();
        }
    } else {
        getNextToken();
    }
}

void HandleExtern() {
    if (auto ProtoAST = ParseExtern()) {
        if (auto *FnIR = ProtoAST->codegen()) {
            fprintf(stderr, "Parsed an extern\n");
            FnIR->dump();
        }
    } else {
        getNextToken();
    }
}

void HandleTopLevelExpression() {
    if (auto FnAST = ParseTopLevelExpr()) {
        if (auto *FnIR = FnAST->codegen()) {
            fprintf(stderr, "Parsed a top-level expr\n");
            FnIR->dump();
        }
    } else {
        getNextToken();
    }
}
